unit GrayScaleMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ExtDlgs, system.Types,
  GDIPAPI, GDIPOBJ;

type
  TForm1 = class(TForm)
    FileOpen: TButton;
    Image1: TImage;
    Image2: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    GrayScaleBtn: TButton;
    GrayScaleDBtn: TButton;
    GrayScaleABtn: TButton;
    GrayScale24Btn: TButton;
    GrayScale4btn: TButton;
    GrayMatBtn: TButton;
    NotGrayMatBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FileOpenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GrayScaleBtnClick(Sender: TObject);
    procedure GrayScaleDBtnClick(Sender: TObject);
    procedure GrayScaleABtnClick(Sender: TObject);
    procedure GrayScale24BtnClick(Sender: TObject);
    procedure GrayScale4btnClick(Sender: TObject);
    procedure GrayMatBtnClick(Sender: TObject);
    procedure NotGrayMatBtnClick(Sender: TObject);
  private
    { Private 錾 }
    procedure TemplateMake;      // Templatef[^[쐬
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

type
  TPrgbarry = array[0..0] of Trgbtriple;      // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray  = ^TPrgbarry;                    // |C^[
                                              // z̃|C^[KvȂȂ̂ŁA1 [0..0]Ŗ肠܂B

// TMaxLogPalettegpĂǂ̂łA4rbgpO[XP[錾Ă݂܂
  T16LogPalette = packed record               // 4rbgpO[XP[@pbg R[h DelphiɂȂ̂ōŐ錾
    palVersion: Word;                         // Delphi ł record ̉ϒ錾ł܂
    palNumEntries: Word;
    palPalEntry: array [0..15] of TPaletteEntry; // TPaletteEntry32 rbgJ[
  end;


implementation

{$R *.dfm}
const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHW   = 384;                            // \gTCY


  RK    = 0.298912;                           // O[XP[PxW@
  GK    = 0.586611;                           // O[XP[PxW@
  BK    = 0.114478;                           // O[XP[PxW@
  BISU  = 1024;                               // {
  RSISF = 10;                                 // rbgVtg

  ColorMatrix_NotGrayScale : TColorMatrix = (       // GDI J[Rg[}gbNX
    (-0.298912, -0.298912, -0.298912,  0.0,  0.0),
    (-0.586611, -0.586611, -0.586611,  0.0,  0.0),
    (-0.114478, -0.114478, -0.114478,  0.0,  0.0),
    ( 0.0,       0.0,       0.0,       1.0,  0.0),
    ( 1.0,       1.0,       1.0,       0.0,  1.0));

  ColorMatrix_GrayScale : TColorMatrix = (          // GDI J[Rg[}gbNX
    ( 0.298912,  0.298912,  0.298912,  0.0,  0.0),
    ( 0.586611,  0.586611,  0.586611,  0.0,  0.0),
    ( 0.114478,  0.114478,  0.114478,  0.0,  0.0),
    ( 0.0,       0.0,       0.0,       1.0,  0.0),
    ( 0.0,       0.0,       0.0,       0.0,  1.0));

var
  InBitmap        : TBitmap;                  // rbg}bv
  OutBitmap       : TBitmap;
  OutBitmap24     : TBitmap;
  OutBitmap4      : TBitmap;
  GHeight, GWidth : integer;                  // \[X摜TCY
  Vrect           : Trect;                    // \g
  IHeight, IWidth : Integer;                  // \TCY
  RTemp           : array[0..255] of Cardinal;  // ev[gpz@
  GTemp           : array[0..255] of Cardinal;  // ev[gpz  
  BTemp           : array[0..255] of Cardinal;  // ev[gpz  

// Tone ɊKZbg gpł̂́@256, 16, 2  łB
function CreateGrayScalePaletteS(Tone: WORD): HPALETTE; // Tone ɊKZbg
var
  Palette : ^TLogPalette;                               // TLogPalette ̃|C^[
  i       : Integer;
  BD      : BYTE;
begin
   GetMem(Palette, SizeOf(TLogPalette) + SizeOf(TPaletteEntry) * Tone);   // TLogPalette͌Œ蒷̔zȂ̂ŕKvȃm
   Palette^.palNumEntries := Tone;                                        // KZbg
   Palette^.palVersion := $0300;                                          // o[WZbg
   BD := 255 div (Tone - 1);                                              // KvZ
   for i := 0 to Tone - 1 do begin                                        // Kf[^[Zbg
      Palette^.palPalEntry[i].peRed   := BD * i;
      Palette^.palPalEntry[i].peGreen := BD * i;
      Palette^.palPalEntry[i].peBlue  := BD * i;
      Palette^.palPalEntry[i].peFlags := 0;                               // tO͎gpȂ
   end;
   Result := CreatePalette(Palette^);
   FreeMem(Palette);
end;

// 16~
function Create16ScalePalette: HPALETTE;            // O[4rbgpbgɐݒ
const
  Tone = 16;                                        // 16K
var
  Palette: T16LogPalette;
  i: Integer;
begin
  Palette.palNumEntries := Tone;                    // 16KZbg
  Palette.palVersion := $0300;                      // pbgo[W
  for i := 0 to Tone - 1 do begin                   // pbgf[^[̐ݒ
    Palette.palPalEntry[ i ].peRed   := 17 * i;
    Palette.palPalEntry[ i ].peGreen := 17 * i;
    Palette.palPalEntry[ i ].peBlue  := 17 * i;
    Palette.palPalEntry[ i ].peFlags := 0;          // tO͎gpȂ
  end;
  Result := CreatePalette(PLogPalette(@Palette)^);
end;

// 256~
function CreateGrayScalePalette: HPALETTE;          // O[Wrbgpbgɐݒ
const
  Tone = 256;                                       // 256K
var
  Palette: TMaxLogPalette;
  i: Integer;
begin
  Palette.palNumEntries := Tone;                    // 256KZbg
  Palette.palVersion := $0300;                      // pbgo[W
  for i := 0 to Tone - 1 do begin                   // pbgf[^[̐ݒ
    Palette.palPalEntry[ i ].peRed   := i;
    Palette.palPalEntry[ i ].peGreen := i;
    Palette.palPalEntry[ i ].peBlue  := i;
    Palette.palPalEntry[ i ].peFlags := 0;
  end;
  Result := CreatePalette(PLogPalette(@Palette)^);
end;

// NTSC W1024{ăev[gf[^[쐬
procedure TForm1.TemplateMake;      // Templatef[^[쐬
var
  II : Integer;
begin
  for II := 0 to 255 do begin
    RTemp[II] := round(RK * BISU * II);                       // ԃev[g
    GTemp[II] := round(GK * BISU * II);                       // ΃ev[g
    BTemp[II] := round(BK * BISU * II);                       // ev[g
  end;
end;

// t@C̃I[v@WIC@t@C̎ނ̂Ŏgp
procedure TForm1.FileOpenClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
begin
  GrayScaleBtn.Enabled    := False;
  GrayScaleDBtn.Enabled   := False;
  GrayScaleABtn.Enabled   := False;
  GrayScale24Btn.Enabled  := False;
  GrayScale4Btn.Enabled := False;
  GrayMatBtn.Enabled    := False;
  NotGrayMatBtn.Enabled := False;
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  Image2.Canvas.Brush.Style := bsSolid;
  Image2.Canvas.Brush.Color := clBtnface;
  Image2.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        IWidth  := ImageHW;                                   // o͐C[W1̕
        IHeight := ImageHW;                                   // o͐C[W1̍
        if GHeight <= GWidth then                             // cɂo̓TCYݒ
          IHeight := Round(IWidth * GHeight / GWidth)
        else
          IWidth := Round(IHeight * GWidth / GHeight);
        Image1.Width := IWidth;
        Image1.Height:= IHeight;
        Image1.Picture.Bitmap.SetSize(IWidth, IHeight);       // \prbg}bvTCY̐ݒ
        Image2.Width := IWidth;
        Image2.Height:= IHeight;
        Image2.Picture.Bitmap.SetSize(IWidth, IHeight);       // \prbg}bvTCY̐ݒ
        VRect := Rect(0, 0, IWidth, IHeight);                 // o͘gݒ
        Image1.Canvas.StretchDraw(VRect, WIC);                // o͘gɕϔ{o
        InBitmap.Width    := GWidth;
        InBitmap.Height   := GHeight;
        InBitmap.Canvas.Draw(0, 0, WIC);                      // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ܂
        OutBitmap.Width   := GWidth;
        OutBitmap.Height  := GHeight;
        OutBitmap24.Width := GWidth;
        OutBitmap24.Height:= GHeight;
        OutBitmap4.Width  := GWidth;
        OutBitmap4.Height := GHeight;
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else Exit;
  GrayScaleBtn.Enabled    := True;
  GrayScaleDBtn.Enabled   := True;
  GrayScaleABtn.Enabled   := True;
  GrayScale24Btn.Enabled  := True;
  GrayScale4Btn.Enabled   := True;
  GrayMatBtn.Enabled      := True;
  NotGrayMatBtn.Enabled   := True;
end;

// }gbNXgpăO[摜̐
procedure TForm1.GrayMatBtnClick(Sender: TObject);
var
  Gpgraph : TGPGraphics;
  GPImage  : TGPImage;
  GPImageAttr : TGPImageAttributes;
  Astream     : TMemoryStream;
begin
  // GPImage := TGPImage.Create(InFilename);   // TGPImageɃt@C֘At
  // t@CǂݍޑɃ[֏o͂[ǂݍ݂܂
  // [Xg[쐬 inbitmap o
  Astream := TMemoryStream.Create;
  InBitmap.SaveToStream(Astream);

  // [Xg[CTGPBitmap̃IuWFNgɓǂݍݎw
  GPImage := TGPBitmap.Create(TStreamAdapter.Create(AStream, soReference));

  // GD+TBitmap̕`nhݒ
  Gpgraph := TGPGraphics.Create(OutBitmap24.Canvas.Handle);

  // TGPImageAttributes̃IuWFNg𐶐
  GPImageAttr := TGPImageAttributes.Create;
  GPImageAttr.SetGamma(1.0);                              // K}lݒ
  // gp}gbNXAgr[gɐݒ
  GPImageAttr.SetColorMatrix(ColorMatrix_GrayScale);

  // TCanvasStretchDrawɑ
  // GpgraphHandleOutBitmap24.CanvasɎw肳Ă̂OutBitmap24.Canvasɕ`悳܂
  Gpgraph.DrawImage(                                      // Gpgraph (OutBitmap24) ɕ`
              GPImage,                                    // 摜
              MakeRect(0, 0, GWidth, GHeight),            // o͈ʒu TCY@
              0, 0, GPImage.GetWidth, GPImage.GetHeight,  // ͈ʒu TCY
              UnitPixel,                                  // sNZ
              GPImageAttr);                               // Agr[g

  Image2.Canvas.StretchDraw(Vrect, OutBitmap24);          // Image1 Dbitmapϔ{\

  //CreateIuWFNg͉܂B
  GPImageAttr.Free;
  GPImage.Free;
  Gpgraph.Free;
  Astream.Free;
end;

// pbggpɁA24rbgJ[[h R,G,B  ɓl݂܂
procedure TForm1.GrayScale24BtnClick(Sender: TObject);        // pbggpRGBlZbg
var
  II, JJ        : Integer;
  InpPrgbarray  : Prgbarray;
  OutParray     : Prgbarray;
  OutInt        : DWORD;
  OutByte       : BYTE;
begin
  for II := 0 to GHeight - 1 do begin
    InpPrgbarray  := InBitmap.ScanLine[II];                   // C|C^ݒ
    OutParray     := OutBitmap24.ScanLine[II];
    for JJ := 0 to GWidth - 1 do begin                        // OFZ
      OutInt :=   RTemp[InpPrgbarray[JJ].rgbtRed]             // ԃev[g
                + GTemp[InpPrgbarray[JJ].rgbtGreen]           // ΃ev[g
                + BTemp[InpPrgbarray[JJ].rgbtBlue];           // ev[g
      OutByte := OutInt shr RSISF;                            // 10rbgEVtg OutInt div 1024
      OutParray[JJ].rgbtBlue  := OutByte;                     // OFlZbg
      OutParray[JJ].rgbtGreen := OutByte;
      OutParray[JJ].rgbtRed   := OutByte;
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap24);              // o͘gɕϔ{o
end;

// 16KO[pbggpĕ\
procedure TForm1.GrayScale4btnClick(Sender: TObject);         // 4rbg 16K\
var                                                           // NTSCWgp
  II, JJ        : Integer;
  InpPrgbarray  : Prgbarray;
  OutParray     : Prgbarray;
  OutInt        : DWORD;
  OutByte       : BYTE;
begin
  for II := 0 to GHeight - 1 do begin
    InpPrgbarray  := InBitmap.ScanLine[II];                   // C|C^ݒ
    OutParray     := OutBitmap24.ScanLine[II];
    for JJ := 0 to GWidth - 1 do begin                        // OFZ
      OutInt :=   RTemp[InpPrgbarray[JJ].rgbtRed]             // ԃev[g
                + GTemp[InpPrgbarray[JJ].rgbtGreen]           // ΃ev[g
                + BTemp[InpPrgbarray[JJ].rgbtBlue];           // ev[g
      OutByte := OutInt shr RSISF;                            // 10rbgEVtg OutInt div 1024
      OutParray[JJ].rgbtBlue  := OutByte;                     // OFlZbg
      OutParray[JJ].rgbtGreen := OutByte;
      OutParray[JJ].rgbtRed   := OutByte;
    end;
  end;
  OutBitmap4.Canvas.Draw(0, 0, OutBitmap24);                  // 16Kpbgɕ`
  Image2.Canvas.StretchDraw(VRect, OutBitmap4);               // o͘gɕϔ{o
end;

// R,G,B̕ϒlgpāA\@\256KO[pbggp
procedure TForm1.GrayScaleABtnClick(Sender: TObject);         // ϒlvZo
var
  II, JJ        : Integer;
  InpPrgbarray  : Prgbarray;
  OutParray     : Pbytearray;
  OutInt        : WORD;
begin
  for II := 0 to GHeight - 1 do begin
    InpPrgbarray  := InBitmap.ScanLine[II];                   // C|C^ݒ
    OutParray     := OutBitmap.ScanLine[II];
    for JJ := 0 to GWidth - 1 do begin                        // OFZ
      OutInt :=   InpPrgbarray[JJ].rgbtRed                    // 
                + InpPrgbarray[JJ].rgbtGreen                  // 
                + InpPrgbarray[JJ].rgbtBlue;                  // 
      OutParray[JJ] := OutInt div 3;                          // ϒl OutInt div 3
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
end;

// NTSCWgpċPxvZ@O[XP[pbggpĕ\
procedure TForm1.GrayScaleBtnClick(Sender: TObject);          // O[XP[ϊ
var                                                           // NTSCWgp
  II, JJ        : Integer;
  InpPrgbarray  : Prgbarray;
  OutParray     : Pbytearray;
  OutInt        : DWORD;
begin
  for II := 0 to GHeight - 1 do begin
    InpPrgbarray  := InBitmap.ScanLine[II];                   // C|C^ݒ
    OutParray     := OutBitmap.ScanLine[II];
    for JJ := 0 to GWidth - 1 do begin
      OutInt :=   RTemp[InpPrgbarray[JJ].rgbtRed]             // ԃev[g
                + GTemp[InpPrgbarray[JJ].rgbtGreen]           // ΃ev[g
                + BTemp[InpPrgbarray[JJ].rgbtBlue];           // ev[g
      OutParray[JJ] := OutInt shr RSISF;                      // 10rbgEVtg OutInt div 1024
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
end;

// O[XP[pbggpāAڕϊ\
procedure TForm1.GrayScaleDBtnClick(Sender: TObject);         // ڏo ϊ VXeC
begin
  OutBitmap.Canvas.Draw(0, 0, InBitmap);                      // OutBitmapɕ`AO[ϊ̓pbgC
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
end;

// ]}gbNXgpĔ]O[摜̐
procedure TForm1.NotGrayMatBtnClick(Sender: TObject);
var
  Gpgraph : TGPGraphics;
  GPImage  : TGPImage;
  GPImageAttr : TGPImageAttributes;
  Astream     : TMemoryStream;
begin
  // GPImage := TGPImage.Create(InFilename);   // TGPImageɃt@C֘At
  // t@CǂݍޑɃ[֏o͂[ǂݍ݂܂
  // [Xg[쐬 inbitmap o
  Astream := TMemoryStream.Create;
  InBitmap.SaveToStream(Astream);

  // [Xg[CTGPBitmap̃IuWFNgɓǂݍݎw
  GPImage := TGPBitmap.Create(TStreamAdapter.Create(AStream, soReference));

  // GD+TBitmap̕`nhݒ
  Gpgraph := TGPGraphics.Create(OutBitmap24.Canvas.Handle);

  // TGPImageAttributes̃IuWFNg𐶐
  GPImageAttr := TGPImageAttributes.Create;
  GPImageAttr.SetGamma(1.0);                              // K}lݒ
  // gp}gbNXAgr[gɐݒ
  GPImageAttr.SetColorMatrix(ColorMatrix_NotGrayScale);

  // TCanvasStretchDrawɑ
  // GpgraphHandleOutBitmap24.CanvasɎw肳Ă̂OutBitmap24.Canvasɕ`悳܂
  Gpgraph.DrawImage(                                      // Gpgraph (OutBitmap24) ɕ`
              GPImage,                                    // 摜
              MakeRect(0, 0, GWidth, GHeight),            // o͈ʒu TCY@
              0, 0, GPImage.GetWidth, GPImage.GetHeight,  // ͈ʒu TCY
              UnitPixel,                                  // sNZ
              GPImageAttr);                               // Agr[g

  Image2.Canvas.StretchDraw(Vrect, OutBitmap24);          // Image1 Dbitmapϔ{\

  //CreateIuWFNg͉܂B
  GPImageAttr.Free;
  GPImage.Free;
  Gpgraph.Free;
  Astream.Free;
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  GrayScaleBtn.Enabled  := False;
  GrayScaleDBtn.Enabled := False;
  GrayScaleABtn.Enabled := False;
  GrayScale24Btn.Enabled := False;
  GrayScale4Btn.Enabled := False;
  GrayMatBtn.Enabled    := False;
  NotGrayMatBtn.Enabled := False;
  Image1.Width  := ImageHW;
  Image1.Height := ImageHW;
  Image2.Width  := ImageHW;
  Image2.Height := ImageHW;
  InBitmap      := TBitmap.Create;                            // ͉摜p
  OutBitmap     := TBitmap.Create;                            // 8rbgo͗p
  OutBitmap24   := TBitmap.Create;                            // 24rbgo͗p
  OutBitmap4    := TBitmap.Create;                            // 4rbgo͗p
  InBitmap.PixelFormat    := pf24bit;                         // 24rbgJ[ɐݒ
  OutBitmap24.PixelFormat := pf24bit;                         // 24rbgJ[ɐݒ
  OutBitmap.PixelFormat   := pf8bit;                          // 8rbgɐݒ
  OutBitmap.Palette := CreateGrayScalePalette;                // OC256Kɐݒ
  OutBitmap4.PixelFormat  := pf4bit;                          // 4rbgɐݒ
//  OutBitmap4.Palette := Create16ScalePalette;
  OutBitmap4.Palette := CreateGrayScalePaletteS(16);          // O[16KɃpbgݒ
  TemplateMake;                                               // Templatef[^[쐬
end;

// rbg}bv̉
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  OutBitmap.Free;
  OutBitmap24.Free;
  OutBitmap4.Free;
end;

end.
